/*
 * CC3OSXExtensions.m
 *
 * Cocos3D 2.0.1
 * Author: Bill Hollings
 * Copyright (c) 2010-2014 The Brenwill Workshop Ltd. All rights reserved.
 * http://www.brenwill.com
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * http://en.wikipedia.org/wiki/MIT_License
 * 
 * See header file CC3OSXExtensions.h for full API documentation.
 */

#import "CC3OSXExtensions.h"
#import	"CC3Logging.h"


#if CC3_OSX


#pragma mark -
#pragma mark Open GL Context

@implementation NSOpenGLContext (CC3)

-(void) ensureCurrentContext {
	if (self.class.currentContext != self) [self makeCurrentContext];
}

-(CC3GLContext*) asSharedContext {
	CC3Assert(self.view, @"%@ has no view and cannot be the source of a shared context.", self);
	return [[[self.class alloc] initWithFormat: ((NSOpenGLView*)self.view).pixelFormat
								  shareContext: self] autorelease];
}

@end

#endif	// CC3_OSX

